module("luci.controller.qmodem",package.seeall)
local t=require"luci.http"
local s=require"nixio.fs"
local a=require("luci.jsonc")
uci=luci.model.uci.cursor()
local h="/usr/share/qmodem/"
local r="/tmp/run/qmodem/"
local o="/usr/share/qmodem/modem_ctrl.sh "
function index()
if not nixio.fs.access("/etc/config/qmodem")then
return
end
entry({"admin","modem"},firstchild(),_("Modem"),25).dependent=false
entry({"admin","modem","qmodem"},alias("admin","modem","qmodem","modem_info"),luci.i18n.translate("QModem"),100).dependent=true
entry({"admin","modem","qmodem","modem_info"},template("qmodem/modem_info"),luci.i18n.translate("QModem Information"),2).leaf=true
entry({"admin","modem","qmodem","get_modem_cfg"},call("getModemCFG"),nil).leaf=true
entry({"admin","modem","qmodem","modem_ctrl"},call("modemCtrl")).leaf=true
entry({"admin","modem","qmodem","dial_overview"},cbi("qmodem/dial_overview"),luci.i18n.translate("Dial Overview"),3).leaf=true
entry({"admin","modem","qmodem","dial_config"},cbi("qmodem/dial_config")).leaf=true
entry({"admin","modem","qmodem","modems_dial_overview"},call("getOverviews"),nil).leaf=true
entry({"admin","modem","qmodem","modem_debug"},template("qmodem/modem_debug"),luci.i18n.translate("Advance Modem Settings"),4).leaf=true
entry({"admin","modem","qmodem","send_at_command"},call("sendATCommand"),nil).leaf=true
entry({"admin","modem","qmodem","settings"},cbi("qmodem/settings"),luci.i18n.translate("QModem Settings"),100).leaf=true
entry({"admin","modem","qmodem","slot_config"},cbi("qmodem/slot_config")).leaf=true
end
function shell(e)
local e=io.popen(e)
local t=e:read("*a")
e:close()
return t
end
function translate_modem_info(e)
modem_info=e["modem_info"]
response={}
for t,e in pairs(modem_info)do
if type(e)=="table"then
key=e["key"]
full_name=e["full_name"]
if full_name then
full_name=luci.i18n.translate(full_name)
elseif key then
full_name=luci.i18n.translate(key)
end
e["full_name"]=full_name
if e["class"]then
e["class"]=luci.i18n.translate(e["class"])
end
table.insert(response,e)
end
end
return response
end
function modemCtrl()
local e=t.formvalue("action")
local i=t.formvalue("cfg")
local n=t.formvalue("params")
local t=t.formvalue("translate")
if n then
result=shell(o..e.." "..i.." ".."\""..n.."\"")
else
result=shell(o..e.." "..i)
end
if t=="1"then
modem_more_info=a.parse(result)
modem_more_info=translate_modem_info(modem_more_info)
result=a.stringify(modem_more_info)
end
luci.http.prepare_content("application/json")
luci.http.write(result)
end
function at(e,t)
local e="source "..h.."modem_util.sh && at "..e.." "..t
local e=shell(e)
e=string.gsub(e,"\r","")
return e
end
function getOverviews()
local i={}
local t={}
uci:foreach("qmodem","modem-device",function(e)
section_name=e[".name"]
modem_name=e["name"]or luci.i18n.translate("Unknown")
alias=e["alias"]
modem_state=e["state"]
if modem_state=="disabled"then
return
end
cmd=o.."base_info "..section_name
result=shell(cmd)
json_result=a.parse(result)or"{}"
modem_info=json_result["modem_info"]
tmp_info={}
if alias then
title=alias.."("..modem_name..")"
else
title=modem_name
end
name={
type="plain_text",
key="name",
value=title
}
table.insert(tmp_info,name)
for t,e in pairs(modem_info)do
full_name=e["full_name"]
if full_name then
e["full_name"]=luci.i18n.translate(full_name)
end
table.insert(tmp_info,e)
end
table.insert(i,tmp_info)
log_path=r..section_name.."_dir/dial_log"
if s.access(log_path)then
log_msg=s.readfile(log_path)
modem_log={}
modem_log["log_msg"]=log_msg
modem_log["section_name"]=section_name
if alias then
modem_log["name"]=alias.."("..modem_name..")"
else
modem_log["name"]=modem_name
end
table.insert(t,modem_log)
end
end)
local e={}
e["modems"]=i
e["logs"]=t
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function getModemCFG()
local a={}
local s={}
uci:foreach("qmodem","modem-device",function(e)
modem_state=e["state"]
if modem_state=="disabled"then
return
end
local t=e["modem"]
local t=e["alias"]
local o=e[".name"]
local i=e[".name"]
local n=e["at_port"]
local o=e["name"]:upper()
local e={}
if t then
e["name"]=t.."("..o..")"
else
e["name"]=o
end
e["at_port"]=n
e["cfg"]=i
table.insert(a,e)
end)
local e={}
e["cfgs"]=a
e["translation"]=s
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function sendATCommand()
local a=t.formvalue("port")
local t=t.formvalue("command")
local e={}
if a and t then
e["response"]=at(a,t)
e["time"]=os.date("%Y-%m-%d %H:%M:%S")
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
